// FftCrash.cpp :  DLL Ӧóڵ㡣
//
#pragma comment(lib, "cudart.lib")
#pragma comment(lib, "cufft.lib")
#pragma comment(lib, "cutil32.lib")

#include "stdafx.h"
#include <cufft.h>
#include <cutil.h>

#define SIGNAL_SIZE 1024*1024
#define Success 0

#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif

typedef float2 Complex; 

cufftHandle g_plan;
Complex* g_d_signal;
Complex* g_h_signal;

__global__ void Test_kernel(Complex *data, float scale)
{
	unsigned int xIndex = __mul24( blockDim.x, blockIdx.x ) + threadIdx.x;
	unsigned int yIndex = __mul24( blockDim.y, blockIdx.y ) + threadIdx.y; 

	data[xIndex].x = 1/scale;	
}

extern "C" _declspec(dllexport) int InitFFT(void)
{
	// Allocate host memory for the signal
    g_h_signal = (Complex*)malloc(sizeof(Complex) * SIGNAL_SIZE);
    // Initalize the memory for the signal
    for (unsigned int i = 0; i < SIGNAL_SIZE; ++i) {
        g_h_signal[i].x = rand() / (float)RAND_MAX;
        g_h_signal[i].y = 0;
    }

    // Allocate device memory for signal
    CUDA_SAFE_CALL(cudaMalloc((void**)&g_d_signal, sizeof(Complex) * SIGNAL_SIZE));
    // Copy host memory to device
    CUDA_SAFE_CALL(cudaMemcpy(g_d_signal, g_h_signal, sizeof(Complex) * SIGNAL_SIZE, cudaMemcpyHostToDevice));

    // CUFFT plan
    CUFFT_SAFE_CALL(cufftPlan1d(&g_plan, SIGNAL_SIZE, CUFFT_C2C, 1));

	return Success;
}



extern "C" __declspec(dllexport) int CrashTest()
{
	dim3 dimG(16, 16);
	dim3 dimB(16, 16);
	cudaError_t err = cudaSuccess;
	Test_kernel<<<dimG, dimB>>>(NULL, 0);//make a cudaErrorLaunchFailure (intended)
	err = cudaThreadSynchronize();//will return cudaErrorLaunchFailure
	return err;
}

//extern "C" __declspec(dllexport) int FftTest()
//{
//	int res = cufftExecC2C(g_plan, g_d_signal, g_d_signal, CUFFT_FORWARD);
//	return res;
//}

extern "C" __declspec(dllexport) int Release()
{ 
	//Application will crash at this spot whatever you use is CUDA1.1 or CUDA2.0 Beta2.
	//If this line is commented, cufft will still print error message CUFFT_INTERNAL_ERROR.
	int res = cufftDestroy(g_plan);
	return res;
}





